<?php

namespace App\Http\Controllers\Resources;

use Illuminate\Http\Request;
use App\Http\Requests\ArticleRequest;
use App\Http\Requests\ExportRequest;
use App\Http\Requests\ImportRequest;
use App\Http\ReportGenerator\PdfReport;
use App\Http\ReportGenerator\ExcelReport;
use App\Http\Controllers\Controller;
use App\Http\Filters\QueryBuilder;

use App\Article;

class ArticleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $queryBuilder = new QueryBuilder(new Article, $request);

        return response()->json($queryBuilder->build()->paginate(10),200);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  App\Http\Requests\ArticleRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ArticleRequest $request)
    {
      return response()->json(tap(new Article($request->all()), function ($article) {
          $article->save();
      }), 201);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
      $article=Article::find($id);

  		if (!$article) {
  			return response()->json(['errors'=>array(['code'=>404,'message'=>__('articles.not_find')])],404);
  		}

  		return response()->json(['status'=>'ok','data'=>$article],200);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  App\Http\Requests\ArticleRequest  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(ArticleRequest $request, $id)
    {
      $article=Article::find($id);

      if (!$article) {
        return response()->json(['errors'=>array(['code'=>404,'message'=>__('articles.not_find')])],404);
      }

      return tap($article)->update($request->all());
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      $article=Article::find($id);

      if (!$article) {
        return response()->json(['errors'=>array(['code'=>404,'message'=>__('articles.not_find')])],404);
      }

      $article->delete();

      return response()->json(['code'=>204,'message'=>__('strings.deleted_successfully')],204);
    }


    /**
     * Display report from a listing of the resource.
     *
     * @param  App\Http\Requests\ExportRequest $request
     * @return PDF CSV or XLS
     */
    public function export(ExportRequest $request)
    {
      $format = $request->input('format');
      $orderBy = $request->input('order_by');
      $betweenDates = ($request->input('between_dates')) ? explode(',', $request->input('between_dates')): ['',''];

      $queryBuilder = new QueryBuilder(new Article, $request);

      $meta = [ // For displaying filters description on header
          __('strings.registered_on') => $betweenDates[0].' - '.$betweenDates[1],
          __('strings.order_by') => $orderBy,
      ];

      $columns = [ // Set Column to be displayed
          __('articles.name') => 'name',
          __('articles.description') => 'description',
          __('articles.type') => function($type) { // You can do if statement or any action do you want inside this closure
              return ($type->type == 1) ? __('articles.product') : __('articles.service');
          },
          __('articles.priece') => 'priece',
      ];

      switch ($format) {
        case 'pdf':
          $report = new PdfReport();
          return $report->of(__('articles.report_title'), $meta, $queryBuilder->build()->get(), $columns)->editColumns([__('articles.priece')], ['class' => 'right bold'])->showTotal([__('articles.priece') => '$'])->download(__('articles.report_title'));
        case 'excel':
          $report = new ExcelReport();
          return $report->of(__('articles.report_title'), $meta, $queryBuilder->build()->get(), $columns)->setView('reports.list-excel-template')->download(__('articles.report_title'));
        case 'csv':
          $report = new ExcelReport();
          return $report->of(__('articles.report_title'), $meta, $queryBuilder->build()->get(), $columns)->simple()->setFormat('csv')->download(__('articles.report_title'));
        default:
          $report = new PdfReport();
          return $report->of(__('articles.report_title'), $meta, $queryBuilder->build()->get(), $columns)->editColumns([__('articles.priece')], ['class' => 'right bold'])->showTotal([__('articles.priece') => '$'])->stream();
      }
    }
}
